/*
 * This code originally from CheckFence:
 *   http://checkfence.cvs.sourceforge.net/viewvc/checkfence/c2lsl/examples/
 * and is:
 *
 * Copyright (c) 2007
 *   Sebastian Burckhardt <sburckha@cis.upenn.edu>
 *   Rajeev Alur          <alur@cis.upenn.edu>
 *   Milo Martin          <milom@cis.upenn.edu>
 * All rights reserved.
 *
 *
 * Modifications are by Christos Stergiou <chster@cs.berkeley.edu> and
 * Jacob Burnim <jburnim@cs.berkeley.edu> and are:
 *
 * Copyright (c) 2009, Regents of the University of California
 * All rights reserved.
 *
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 *
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the
 * distribution.
 *
 * Neither the name of the University of California, Berkeley nor the
 * names of its contributors may be used to endorse or promote
 * products derived from this software without specific prior written
 * permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "lazylist.c"

#include <pthread.h>
#include <stdio.h>

list_t list;
int ares[6];
int cres[5];
int rres[3];
pthread_t threads[2];

void i() {
  init_list(&list);
}

void c(int id, value_t val) {
  cres[id] = contains(&list, val, TRUE);
}

void a(int id, value_t val) {
  ares[id] = add(&list, val, TRUE);
}

void r(int id, value_t val) {
  rres[id] = remov(&list, val, TRUE);
}

void* thread0(void* arg) {
  load_load_fence();

  r(2,-1);
  a(3,2);

  store_store_fence();
  return NULL;
}

void* thread1(void* arg) {
  load_load_fence();

  c(4,3);
  a(5,-5);

  store_store_fence();
  return NULL;
}

int main() {
  i();
  a(0,3);
  a(1,7);

  store_store_fence();
  pthread_create(&(threads[0]), NULL, thread0, NULL);
  pthread_create(&(threads[1]), NULL, thread1, NULL);
  pthread_join(threads[0], NULL);
  pthread_join(threads[1], NULL);
  load_load_fence();

  return 0;
}
